#include "Lista.h"
#include "Nodo.h"
#include "Propriedade.h"

Lista::Lista()
{
  head = NULL;
}


Lista::Lista(Nodo *nhead)
{
  head = nhead;
}


void Lista::setHead(Nodo *nhead)
{
  head = nhead;
}


Nodo *Lista::getHead() const
{
  return (head);
}


// Busca o Nodo anterior aquele que tem o nome do Proprietario
Nodo *Lista::buscarPrev(const Propriedade& nitem) const
{
  Nodo *prox = head, *prev;

  while (prox && prox->getItem() != nitem) {
    prev = prox;
    prox = prox->getProx();
  }

  if (!prox)
    prev = NULL;

  return(prev);
}




// Busca um Nodo pelo nome do Proprietario
Nodo *Lista::buscar(const Propriedade& nitem) const
{
  Nodo *prox = head;

  while (prox && prox->getItem() != nitem)
    prox = prox->getProx();

  return(prox);
}


// Insere Propriedade aps um Nodo
void Lista::inserir(Propriedade& nitem, Nodo *prev)
{
  Nodo *prox;

  prox = new Nodo(nitem);
  prox->setProx(prev->getProx());
  prev->setProx(prox);

}


void Lista::remover(Nodo *prev)
{
  Nodo *remNodo;

  if (prev) {
    remNodo = prev->getProx();
    prev->setProx(remNodo->getProx());
    delete remNodo;
  }
}



// Adicionais

// Insere Propriedade como a cabeca da lista
void Lista::inserir(Propriedade& nitem)
{
  Nodo *prox;

  prox = new Nodo(nitem);
  prox->setProx(head);
  head = prox;
}


void Lista::remover(const Propriedade& nitem)
{
  Nodo *remNodo;

  remover (buscarPrev(nitem));

}


int Lista::getNumItens() const
{
  int count = 0;
  Nodo *prox = head;

  while (prox) {
    count++;
    prox = prox->getProx();
  }

  return (count);
}


